Purpose unclear of unknown file /etc/apache2/apache2.conf.in

Bug #1899611 reported by thermoman on 2020-10-13
16
This bug affects 1 person
Affects Status Importance Assigned to Milestone
apache2 (Ubuntu)
Medium
Bryce Harrington
Xenial
Undecided
Unassigned

Bug Description

[Impact]
Due to a recent SRU fix, a stray config file template gets installed on Xenial systems when apache2 is installed. This causes no harm in practice but may cause some confusion.

[Test Case]
* Install apache2
* Look for /etc/apache2/apache2.conf.in

[Where Problems Could Occur]
The fix changes what gets installed to /etc/apache2, so issues to watch for would relate to unexpected changes in the contents of this directory tree.

[Original
I just upgraded apache2:amd64 2.4.18-2ubuntu3.15 --> 2.4.18-2ubuntu3.17 and now there is a file

  /etc/apache2/apache2.conf.in

with the following difference to apache2.conf:

% diff -u /etc/apache2/apache2.conf /etc/apache2/apache2.conf.in
--- /etc/apache2/apache2.conf 2020-08-13 03:35:57.000000000 +0200
+++ /etc/apache2/apache2.conf.in 2020-07-21 05:13:31.000000000 +0200
@@ -71,7 +71,7 @@
 #
 # The accept serialization lock file MUST BE STORED ON A LOCAL DISK.
 #
-#Mutex file:${APACHE_LOCK_DIR} default
+___MUTEX___Mutex file:${APACHE_LOCK_DIR} default

 #
 # PidFile: The file in which the server should record its process

apache2.conf.in is part of the .deb file, see

  https://packages.ubuntu.com/xenial-updates/amd64/apache2/filelist

apache2.conf.in is not mentioned in any config file in /etc/apache2,
not in the init.d script or systemd service file nor in the changelog.

What's the purpose of that file?

From the diff above it doesn't even look like a valid apache2 config file
because of the "___MUTEX___" prefix.

Is this some kind of leftover from a search/replace operation?

Related branches

Thanks for your report and for making Ubuntu better.

I can confirm this bug. The .in file was added as of:

apache2 (2.4.18-2ubuntu3.16) xenial; urgency=medium

  * On Linux, use pthread mutexes. On kfreebsd/hurd, continue using
    fctnl because they lack robust pthread mutexes.
    (LP: #1565744)

 -- Bryce Harrington <email address hidden> Thu, 16 Jul 2020 00:20:55 +0000

but you're correct in saying that the changelog entry does not mention the file. You are also correct in your guess: the file is a leftover of a search-and-replace operation; it should have probably been removed after the replace took place.

Even though the .in file is harmless (Apache will not try to load it in any way), it should not have been installed. I am marking this bug as Triaged and will contact Bryce to sync.

Thanks!

Changed in apache2 (Ubuntu):
status: New → Triaged
importance: Undecided → Medium
Bryce Harrington (bryce) wrote :

Yeah I remember this, thanks for raising it I'll take a look when I get a chance.

tags: added: server-next
Changed in apache2 (Ubuntu):
assignee: nobody → Bryce Harrington (bryce)
Bryce Harrington (bryce) on 2020-11-09
Changed in apache2 (Ubuntu):
status: Triaged → In Progress
Bryce Harrington (bryce) wrote :

debian/apache2.install contains:

debian/bash_completion/a2enmod /usr/share/bash-completion/completions/
debian/config-dir/* /etc/apache2
debian/a2enmod /usr/sbin
...

We need to backport the changes for apache2.install list config-dir contents more explicitly:

debian/config-dir/*-available /etc/apache2
debian/config-dir/*.conf /etc/apache2
debian/config-dir/envvars /etc/apache2
debian/config-dir/magic /etc/apache2

This covers all the items in Xenial's config-dir that we want, i.e.:

$ ls config-dir/
apache2.conf.in conf-available/ envvars magic mods-available/ ports.conf sites-available/

Bryce Harrington (bryce) on 2020-11-19
description: updated
Changed in apache2 (Ubuntu):
status: In Progress → Fix Committed

Hello thermoman, or anyone else affected,

Accepted apache2 into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/apache2/2.4.18-2ubuntu3.18 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, what testing has been performed on the package and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in apache2 (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed verification-needed-xenial

All autopkgtests for the newly accepted apache2 (2.4.18-2ubuntu3.18) for xenial have finished running.
The following regressions have been reported in tests triggered by the package:

passenger/5.0.27-2 (amd64, armhf, s390x, arm64, ppc64el, i386)
mod-wsgi/4.3.0-1.1ubuntu1 (amd64, armhf, s390x, arm64, ppc64el, i386)
apache2/2.4.18-2ubuntu3.18 (amd64, armhf, s390x, arm64, ppc64el, i386)
horizon/2:9.1.2-0ubuntu5 (amd64, armhf, s390x, arm64, ppc64el, i386)
libapache2-mod-python/3.3.1-11ubuntu2 (amd64, armhf, s390x, arm64, ppc64el, i386)
subversion/1.9.3-2ubuntu1.3 (amd64, armhf, s390x, arm64, ppc64el, i386)
php7.0/7.0.33-0ubuntu0.16.04.16 (amd64, armhf, s390x, arm64, ppc64el, i386)

Please visit the excuses page listed below and investigate the failures, proceeding afterwards as per the StableReleaseUpdates policy regarding autopkgtest regressions [1].

https://people.canonical.com/~ubuntu-archive/proposed-migration/xenial/update_excuses.html#apache2

[1] https://wiki.ubuntu.com/StableReleaseUpdates#Autopkgtest_Regressions

Thank you!

All autopkgtests for the newly accepted apache2 (2.4.18-2ubuntu3.18) for xenial have finished running.
The following regressions have been reported in tests triggered by the package:

libapache2-mod-python/3.3.1-11ubuntu2 (amd64, armhf, arm64, i386, ppc64el, s390x)
php7.0/7.0.33-0ubuntu0.16.04.16 (amd64, armhf, arm64, i386, ppc64el, s390x)
mod-wsgi/4.3.0-1.1ubuntu1 (amd64, armhf, arm64, i386, ppc64el, s390x)
subversion/1.9.3-2ubuntu1.3 (amd64, armhf, arm64, i386, ppc64el, s390x)
horizon/2:9.1.2-0ubuntu5 (amd64, armhf, arm64, i386, ppc64el, s390x)
apache2/2.4.18-2ubuntu3.18 (amd64, armhf, arm64, i386, ppc64el, s390x)
passenger/5.0.27-2 (amd64, armhf, arm64, i386, ppc64el, s390x)

Please visit the excuses page listed below and investigate the failures, proceeding afterwards as per the StableReleaseUpdates policy regarding autopkgtest regressions [1].

https://people.canonical.com/~ubuntu-archive/proposed-migration/xenial/update_excuses.html#apache2

[1] https://wiki.ubuntu.com/StableReleaseUpdates#Autopkgtest_Regressions

Thank you!

All autopkgtests for the newly accepted apache2 (2.4.18-2ubuntu3.18) for xenial have finished running.
The following regressions have been reported in tests triggered by the package:

mod-wsgi/4.3.0-1.1ubuntu1 (arm64, s390x, amd64, i386, armhf, ppc64el)
php7.0/7.0.33-0ubuntu0.16.04.16 (arm64, s390x, amd64, i386, armhf, ppc64el)
passenger/5.0.27-2 (arm64, s390x, amd64, i386, armhf, ppc64el)
apache2/2.4.18-2ubuntu3.18 (arm64, s390x, amd64, i386, armhf, ppc64el)
subversion/1.9.3-2ubuntu1.3 (arm64, s390x, amd64, i386, armhf, ppc64el)
horizon/2:9.1.2-0ubuntu5 (arm64, s390x, amd64, i386, armhf, ppc64el)
libapache2-mod-python/3.3.1-11ubuntu2 (arm64, s390x, amd64, i386, armhf, ppc64el)

Please visit the excuses page listed below and investigate the failures, proceeding afterwards as per the StableReleaseUpdates policy regarding autopkgtest regressions [1].

https://people.canonical.com/~ubuntu-archive/proposed-migration/xenial/update_excuses.html#apache2

[1] https://wiki.ubuntu.com/StableReleaseUpdates#Autopkgtest_Regressions

Thank you!

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers